Index: mime.c
===================================================================
RCS file: /cvsroot/bogofilter/bogofilter/src/mime.c,v
retrieving revision 1.26
diff -u -r1.26 mime.c
--- mime.c	8 Oct 2004 23:50:04 -0000	1.26
+++ mime.c	7 Nov 2004 21:59:36 -0000
@@ -213,6 +213,7 @@
 
     mime_free (msg_state);
     stackp--;
+
     msg_state = stackp == -1 ? NULL : &msg_stack[stackp];
     
     if (msg_state && parent && parent->child_count > 0)
@@ -260,8 +261,9 @@
 
   if (blen > 2 && buf[0] == '-' && buf[1] == '-') {
 
-    while (buf[blen - 1] == '\r' ||
-           buf[blen - 1] == '\n')
+    while (blen > 2 &&
+	   (buf[blen - 1] == '\r' ||
+	    buf[blen - 1] == '\n'))
   	  blen--;
 
     /* skip initial -- */
@@ -269,7 +271,8 @@
     blen -= 2;
 
     /* skip and note ending --, if any */
-    if (buf[blen-1] == '-' &&
+    if (blen > 2 &&
+	buf[blen-1] == '-' &&
 	buf[blen-2] == '-') {
       b->is_final = true;
       blen -= 2;
